<html>
<head>
<title>Lemmings Level Code Generator</title>
</head>
<body>
Picture (png): <input type="file" style="width:400px" onchange="document.forms[0].elements['file'].value=this.value" /><br />
<form action="makelevel.php" method="post">
<input type="hidden" name="file" value="" />
<input type="submit" value="generate!" />
</form>
<?php

/*

level description

, = empty till end of row (all 0)
,x = repeat line x times
xxx = write xxx to level
xy = repeat x y times

a = rgb(0,0,0)      empty (pumpkin can walk)
b = rgb(0,255,0)    soft material (pumpkin can bash, mine or dig)
c = rgb(255,255,0)  soft material that can only be destroyed left to right
d = rgb(0,255,255)  soft material that can only be destroyed right to left
e = rgb(255,0,255)  hard material (pumpkin cannot get through)
f = rgb(0,0,255)    water (pumpkin will drown)
g = rgb(255,0,0)    fire / some traps (pumpkin will burn)
h = rgb(192,192,0)  trap
i = rgb(0,192,192)  exit
j = rgb(192,0,192)  shredder

*/

if ($_SERVER['REQUEST_METHOD'] == 'POST') {

  echo '<b>Output:</b><br /><br />';

  $file = '';
  $error = '';
  if (isset($_POST['file'])) $file = $_POST['file'];

  if ($file == '') $error = '<b>Error:</b> No filename specified';
  else if (!$size = getimagesize($file)) $error = '<b>Error:</b> Could not determine imagesize, or file not found';
  else if (!$im = ImageCreateFromPng($file)) $error = '<b>Error:</b> Not a valid PNG resource';

  if ($error != '') {

    echo $error;

  } else {

    $colors = array (
      'a' => hexdec('000000'),
      'b' => hexdec('00ff00'),
      'c' => hexdec('ffff00'),
      'd' => hexdec('00ffff'),
      'e' => hexdec('ff00ff'),
      'f' => hexdec('0000ff'),
      'g' => hexdec('ff0000'),
      'h' => hexdec('c0c000'),
      'i' => hexdec('00c0c0'),
      'j' => hexdec('c000c0')
    );

    $output = '';
    $line = '';
    $linecheck = '';
    $linecount = 0;

    for ($i = 0; $i < $size[1]; $i++) {

      $line = '';
      $buffer = '';
      $check = '';

      for ($j = 0; $j < $size[0]; $j++) {

        $rgb = ImageColorAt($im, $j, $i);
        $color = imagecolorsforindex($im, $rgb);
        $curcolor = array_search($color['blue']+256*$color['green']+65536*$color['red'], $colors);
        if (!$curcolor) $curcolor = 'a';

        if ($curcolor != $check && $check != '') {

          if (strlen($buffer) > 1) {

            $line .= $check.strlen($buffer);

          } else {

            $line .= $buffer;

          }

          $buffer = '';

        }

        $buffer .= $curcolor;
        $check = $curcolor;

      }


      // process last buffer
      if (strlen($buffer) > 0) {

        $line .= $check;

      }

      // check for same lines
      if ($line == $linecheck) {

        $linecount++;

      } else {

        if ($linecount > 0) {

          $output .= $linecheck.',';
          if ($linecount > 1) $output .= $linecount;

        }

        $linecheck = $line;
        $linecount = 1;

      }

    }

    // write last linebuffer
    if ($linecount > 1) {

      $output .= $linecheck.','.$linecount;

    } else {

      $output .= $line;

    }

    echo $file.'<br /><textarea style="width:700px;height:400px">var level = \''.$output.'\';'."\n".'</textarea>';

  }

}

?>
</body>
</html>